function [wtOpt, miu_tar_pos_est] = AdaRSVM(ws, miu_sou_pos, miu_sou_neg, vecs_cama, vecs_camb, data_tar_neg, para)

num_im_train = size(vecs_cama,2);
 
%% compute m1
miu_tar_neg = mean(data_tar_neg,2);
miu_tar_pos_est1 = miu_tar_neg + miu_sou_pos - miu_sou_neg;

%% compute m2
tag_ul = zeros(2, num_im_train*num_im_train);
dist_ul = zeros(1, num_im_train*num_im_train);
for i = 1:num_im_train
    dist_ul((i-1)*num_im_train+1:i*num_im_train) = sum(abs(repmat(vecs_cama(:,i), [1 num_im_train]) - vecs_camb));
    tag_ul(1,(i-1)*num_im_train+1:i*num_im_train) = i;
    tag_ul(2,(i-1)*num_im_train+1:i*num_im_train) = 1:num_im_train;
end

[~, ind] = sort(dist_ul);
tag = tag_ul(:, ind);
para.Q = para.Q;
ind_pos = zeros(1,para.Q);
miu_tar_pos_est2 = 0;
for i = 1:para.Q
    ind_pos(i) = ind(1);
    miu_tar_pos_est2 = miu_tar_pos_est2 + abs(vecs_cama(:,tag(1,1)) - vecs_camb(:,tag(2,1)));
    ind(tag(1,:)==tag(1,1) | tag(2,:)==tag(2,1)) = [];
    tag(:,tag(1,:)==tag(1,1) | tag(2,:)==tag(2,1)) = [];
end
miu_tar_pos_est2 = miu_tar_pos_est2 / para.Q;

funCostMin = inf;
for a = 0.5 % fix a for efficiency
% for a = 0:0.2:1
    miu_tar_pos_est = (a * miu_tar_pos_est1 + (1-a) * miu_tar_pos_est2);    
    
    data_tar_pos_est = repmat(miu_tar_pos_est, [1 size(data_tar_neg,2)]);
    
    %% solve optimization problem
    
    data_train = [data_tar_pos_est data_tar_neg];
    num_pos = size(data_tar_pos_est,2);
    num_neg = size(data_tar_neg,2);
    mat_pair = sparse([eye(num_pos) -eye(num_neg)]);
    
    cond = ws' * data_train / para.musqr;
    data_train = [data_train; cond];
    wt = ranksvm(data_train', mat_pair, para.C * ones(size(mat_pair,1),1));
    regCost = wt' * data_train;
    funCost = 1 - (regCost(1:num_pos) - regCost(1+num_pos:end));
    funCost = sum(funCost(funCost>0).^2);    
    if funCost < funCostMin
        aOpt = a;
        funCostMin = funCost;
        wtOpt = wt(1:end-1) + wt(end) * ws / para.musqr;
        miu_tar_pos_est = (aOpt * miu_tar_pos_est1 + (1-aOpt) * miu_tar_pos_est2);
    end
end

